<?php

if( !defined( 'IN_SKY' ) )
exit( 'Access Denied' );

/**
 * @purpose 天空数据操作控制器
 * @author tortoise or sigong
 * @email chixiaosheng05@163.com
 * @QQ 255979
 * @link http://www.flexsns.com
 * 
 * @notice
 * 
 * @createDate 2009.4.25
 * @modified 2009.4.25
 * 
 */

class Controller_SkyCp_Class extends Common_Global_Class 
{
	var $langs;
	
	function Controller_SkyCp_Class()
	{
		parent::Common_Global_Class();
		
		$className = $this->loadClass( 'Model_SkyItem' );
		$_ENV['skyItemModel'] = new $className( $this->db(), $this->config['db']['tablePrefix'] );
		
		$className = $this->loadClass( 'Model_Reply' );
		$_ENV['replyModel'] = new $className( $this->db(), $this->config['db']['tablePrefix'] );
		
		$className = $this->loadClass( 'Model_Broadcast' );
		$_ENV['broadcastModel'] = new $className( $this->db(), $this->config['db']['tablePrefix'] );
		
		$lang = $this->skyLang;
		$this->langs = $lang['array'];
	}
	
	function indexAction(){}
	
	//删除一条天空数据
	function deleteItemAction()
	{
		$userinfo = $this->checkLogin();
		
		if( empty( $userinfo ) )
		$this->dataReturn( $this->langs['can_not_do_this_without_login'], 'failed' );
		
		$itemId = intval( $this->get['itemId'] );
		
		if( $itemId <= 0 )
		$this->dataReturn( $this->langs['parameters_lost'], 'failed' );
		
		if( !$item = $_ENV['skyItemModel']->getone( $itemId ) )
		$this->dataReturn( $this->langs['action_fail_for_data_not_exists'], 'failed' );
		
		if( $item['uid'] != $userinfo['uid'] )
		$this->dataReturn( 'Access Denied.', 'failed' );
		
		if( $_ENV['skyItemModel']->delete( $itemId ) == 0 )
		{
			$this->dataReturn( $this->langs['action_fail_for_data_not_exists'], 'failed' );
		}
		else
		{
			$_ENV['replyModel']->delReply( $itemId );
		}
		
		$this->dataReturn( $this->langs['action_success'] );
		
	}
	
	//顶一下
	function diggItemAction()
	{
		
		$userinfo = $this->checkLogin();
		
		if( empty( $userinfo ) )
		$this->dataReturn( '您没有登录，不能执行该操作', 'failed' );
		
		$itemId = intval( $this->get['itemId'] );
		if( $itemId <= 0 )
		$this->dataReturn( $this->langs['parameters_lost'], 'failed' );
		
		if( !$item = $_ENV['skyItemModel']->getone( $itemId ) )
		$this->dataReturn( $this->langs['action_fail_for_data_not_exists'], 'failed' );
		
		if( $_ENV['skyItemModel']->updateDiggNum( $itemId ) == 0 )
		$this->dataReturn( $this->langs['action_fail_for_data_not_exists'], 'failed' );
		
		if( $this->config['diggItemAddFeed'] == 1 )
		{
			$diggArray = $this->cookie( 'flexsns-sky-digg' );
			
			if( is_array( $diggArray ) && !empty( $diggArray ) )
			{
				$diggNums = array_count_values( $diggArray );
				if( $diggNums[$itemId] >= $this->config['flash']['maxDiggPertime']  )
				$this->dataReturn( $this->replaceLangVars( '{times}', $this->config['flash']['maxDiggPertime'], $this->langs['digg_fail_for_limit'] ), 'failed' );
			}
				
			$diggArray[] = $itemId;
			$this->cookie( 'flexsns-sky-digg', $diggArray, 86400*24 );
			
			$subjectLink = $this->config['flash']['skyUrl'].'/?index-index/itemId-'.$itemId;
			
			$spaceUrl = $this->config['flash']['spaceUrl'];
			
			if( $this->config['showUserInfo'] == 1 )
			{
				$subjectSearchArray = array( '{fromuser}', '{touser}' );
				$subjectReplaceArray[] = '<a href="'.$spaceUrl.$userinfo['uid'].'" target="_blank">'.$userinfo['username'].'</a>&nbsp;';
				$subjectReplaceArray[] = '<a href="space.php?uid='.$spaceUrl.$item['uid'].'" target="_blank">'.$item['account'].'</a>&nbsp;';
				
				$subject = str_replace( $subjectSearchArray, $subjectReplaceArray, $this->config['feedDiggItemTitle'] );
				
				$_ENV['multipleObj']->addFeed( $userinfo['uid'], $userinfo['username'], $subjectLink, $subject, $subjectLink, $item['content'] );
				
				unset( $subject, $subjectSearchArray, $subjectReplaceArray );
			}
			
			
			$subjectSearchArray = array( '{fromuser}', '{touser}' );
			$subjectReplaceArray[] = '<a href="'.$spaceUrl.$userinfo['uid'].'" target="_blank">'.$userinfo['username'].'</a>&nbsp;';
			$subjectReplaceArray[] = $this->langs['str_yours'];
			$subject = str_replace( $subjectSearchArray, $subjectReplaceArray, $this->config['feedDiggItemTitle'] );
			
			$subject .= '&nbsp;(<a href="'.$subjectLink.'" target="_blank" >'.$this->langs['str_view'].'</a>)';
			
			$_ENV['multipleObj']->addNote( $item['uid'], $item['account'], $subject );
		}
		
		
		$this->dataReturn( $this->langs['action_success'] );
		
	}
	
	//回复
	function replyAction()
	{
		
		$userinfo = $this->checkLogin();
		
		if( empty( $userinfo ) )
		$this->dataReturn( $this->langs['can_not_do_this_without_login'], 'failed' );
		
	
		$lastReplyTime = $this->session( 'replyItemTime' );
		$lastReplyTime =  $lastReplyTime[0];
		
		if( $lastReplyTime + $this->config['reply']['postTimeLimit'] > $this->config['nowtime'] )
		{
			$this->dataReturn( $this->replaceLangVars( '{time}', $this->config['reply']['postTimeLimit'], $this->langs['time_limit_between_two_send'] ), 'failed' );
		}
	
		$itemId = intval( $this->post['itemId'] );
		$content = $this->post['content'];
		
		if( $itemId <= 0 )
		$this->dataReturn( $this->langs['parameters_lost'], 'failed' );
		
		if( !$item = $_ENV['skyItemModel']->getone( $itemId ) )
		$this->dataReturn( $this->langs['action_fail_for_data_not_exists'], 'failed' );
		
		if( !$this->checkLength( $content, $this->config['reply']['minLength'], $this->config['reply']['maxLength'] ) )
		$this->dataReturn( $this->replaceLangVars( array( '{minlen}', '{maxlen}' ), array( $this->config['reply']['minLength'], $this->config['reply']['maxLength'] ), $this->langs['reply_length_limit'] ), 'failed' );
		
		if( !$replyId = $_ENV['replyModel']->newReply( $itemId, $userinfo['uid'], $userinfo['username'], $content, $this->config['nowtime']  ) )
		{
			$this->dataReturn( $this->langs['unknown_error'], 'failed' );
		}
		elseif( $this->config['replyItemAddFeed'] == 1 )
		{
			$subjectLink =$this->config['flash']['skyUrl'].'/?index-index/itemId-'.$itemId.'/replyId-'.$replyId;
			
			$spaceUrl = $this->config['flash']['spaceUrl'];
			
			if( $this->config['showUserInfo'] == 1 )
			{
				$subjectSearchArray = array( '{fromuser}', '{touser}' );
				$subjectReplaceArray[] = '<a href="'.$spaceUrl.$userinfo['uid'].'" target="_blank">'.$userinfo['username'].'</a>&nbsp;';
				$subjectReplaceArray[] = '<a href="space.php?uid='.$spaceUrl.$item['uid'].'" target="_blank">'.$item['account'].'</a>&nbsp;';
				
				$subject = str_replace( $subjectSearchArray, $subjectReplaceArray, $this->config['feedReplyItemTitle'] );
				
				$_ENV['multipleObj']->addFeed( $userinfo['uid'], $userinfo['username'], $subjectLink, $subject, $subjectLink, $item['content'] );
				
				unset( $subject, $subjectSearchArray, $subjectReplaceArray );
			}
			
			$subjectSearchArray = array( '{fromuser}', '{touser}' );
			$subjectReplaceArray[] = '<a href="'.$spaceUrl.$userinfo['uid'].'" target="_blank">'.$userinfo['username'].'</a>&nbsp;';
			$subjectReplaceArray[] = $this->langs['str_yours']; 
			$subject = str_replace( $subjectSearchArray, $subjectReplaceArray, $this->config['feedReplyItemTitle'] );
			
			$subject .= '&nbsp;(<a href="'.$subjectLink.'" target="_blank" >'.$this->langs['str_view'].'</a>)';
			
			$_ENV['multipleObj']->addNote( $item['uid'], $item['account'], $subject );
		}
		
		$_ENV['skyItemModel']->updateReplyNum( $itemId );
		$this->session( 'replyItemTime', array( $this->config['nowtime'] ) );
		$this->dataReturn( $this->langs['action_success'] );
		
	}
	
	//获取回复内容
	function getReplyAction()
	{
		$this->get['perpage'] = intval( $this->get['perpage'] );
		$this->get['itemId'] = intval( $this->get['itemId'] );
		
		$this->get['perpage'] = $this->get['perpage'] == 0 ? $this->get['perpage'] = 30 : $this->get['perpage'] ;
		
		$this->get['perpage'] = min( 100, $this->get['perpage'] );
		$this->get['perpage'] = max( 1, $this->get['perpage'] );
		
		$itemId = $this->get['itemId'];
		
		if( $itemId <= 0 )
		$this->dataReturn( $this->langs['parameters_lost'], 'failed' );
		
		$replysNums = $_ENV['replyModel']->replysNums( $itemId );
		
		list( $sqlStart, $perpage, $totalPage ) = $this->pages( './index.php?skycp-getReply/itemId-'.$itemId.'-', $replysNums, $this->get['perpage'] );
		
		$replys =  $_ENV['replyModel']->replys( $itemId, $sqlStart, $perpage );
		
		$this->xmlHeader();
		
		if( !empty( $replys ) )
		{
			echo '<replys pageNums="'.$totalPage.'" replysNums="'.$replysNums.'">'."\n";
			
			$xml = '';
			
			foreach ( $replys as $value )
			{
				$xml .='<reply
				author="'.$value['account'].'" 
				authorUid="'.$value['uid'].'" 
				authorHead="'.$_ENV['multipleObj']->useravatar( $value['uid'], true, 'big' ).'" 
				dateline="'.$this->dateFormat( $value['dateline'], 'date' ).'" >'.$value['content'].'</reply>'."\n";
			}
			
			echo $xml;
			
			echo '</replys>';
			
		}
		else
		{
			echo '<replys pageNums="0" replysNums="0">'."\n";
			
			echo '</replys>';
		}
	}
	
	//获取天空内容
	function itemsAction()
	{
		$this->get['perpage'] = intval( $this->get['perpage'] );
		$this->get['itemId'] = intval( $this->get['itemId'] );
		
		$this->get['perpage'] = $this->get['perpage'] == 0 ? $this->get['perpage'] = $this->config['item']['maxItems'] : $this->get['perpage'] ;
		
		$this->get['perpage'] = min( $this->config['item']['maxItems'], $this->get['perpage'] );
		$this->get['perpage'] = max( 1, $this->get['perpage'] );
		
		$itemId = $this->get['itemId'];
		
		$this->get['perpage'] = $itemId > 0 ? $this->get['perpage'] - 1 : $this->get['perpage'];
		
		$itemNums = $_ENV['skyItemModel']->itemsNums( $itemId );
		
		list( $sqlStart, $perpage, $totalPage ) = $this->pages( './index.php?skycp-items/', $itemNums, $this->get['perpage'] );
		
		$items =  $_ENV['skyItemModel']->items( $sqlStart, $perpage, $itemId );
		
		if( empty( $items ) )
		$items = array();
		
		if( $itemId > 0)
		{
			$focusItem = $_ENV['skyItemModel']->getone( $itemId );
			if( !empty( $focusItem ) )
			{
				$items[] = $focusItem;
			}
			else
			{
				$items[] = array( 'account'=>'system', 'uid'=>0, 'itemid'=>0, 'dateline'=>$this->config['nowtime'], 'digg'=>0, 'reply'=>0, 'content'=>'抱歉,出错了,数据不存在' );
			}
		}
		
		$hotItems =  $_ENV['skyItemModel']->items( 0, 5, 0, ' digg DESC ' );
		$this->_items( $items, $totalPage, $itemNums, $hotItems );
	}

	//获取某用户天空内容
	function userItemsAction()
	{
		$userinfo = $this->checkLogin();
		
		if( $this->config['showUserInfo'] == 0 && $userinfo['uid'] != $this->get['uid'] )
		{
			$this->message( $this->langs['action_fail'],  $this->langs['access_denied_for_read_user_data'], 'failed' );
		}
		
		$this->get['perpage'] = intval( $this->get['perpage'] );
		$this->get['itemId'] = intval( $this->get['itemId'] );
		$this->get['uid'] = intval( $this->get['uid'] );
		
		$this->get['perpage'] = $this->get['perpage'] == 0 ? $this->get['perpage'] = $this->config['item']['maxItems'] : $this->get['perpage'] ;
		
		$this->get['perpage'] = min( $this->config['item']['maxItems'], $this->get['perpage'] );
		$this->get['perpage'] = max( 1, $this->get['perpage'] );
		
		$itemId = $this->get['itemId'];
		$uid = $this->get['uid'];
		
		$this->get['perpage'] = $itemId > 0 ? $this->get['perpage'] - 1 : $this->get['perpage'];
		
		$itemNums = $_ENV['skyItemModel']->userItemsNums( $uid );
		
		list( $sqlStart, $perpage, $totalPage ) = $this->pages( './index.php?skycp-items/', $itemNums, $this->get['perpage'] );
		
		$items =  $_ENV['skyItemModel']->userItems( $uid, $sqlStart, $perpage );
		
		if( empty( $items ) )
		$items = array();
		
		if( $itemId > 0)
		{
			$focusItem = $_ENV['skyItemModel']->getone( $itemId );
			if( !empty( $focusItem ) )
			{
				$items[] = $focusItem;
			}
			else
			{
				$items[] = array( 'account'=>'system', 'uid'=>0, 'itemid'=>0, 'dateline'=>$this->config['nowtime'], 'digg'=>0, 'reply'=>0, 'content'=>'抱歉,出错了,数据不存在' );
			}
		}
		
		$this->_items( $items, $totalPage, $itemNums );
	}
	
	//输出天空数据xml
	function _items( $items, $totalPage, $itemNums, $hotItems = array() )
	{
	
		$this->xmlHeader();
		
		if( !empty( $items ) )
		{
			echo '<items pageNums="'.$totalPage.'" itemsNums="'.$itemNums.'" nowDate="'.$this->dateFormat( $this->config['nowtime'] ).'" >'."\n";
			
			$xml = '';
			
			if( $this->config['showUserInfo'] == 1 )
			{
				foreach ( $items as $value )
				{
					$value['content'] = str_replace( '+', '[@plus@]', $value['content'] );
					$value['account'] = urlencode( $this->d2s( $value['account'] ) );
					$value['content'] = urlencode( $value['content'] );
					$value['content'] = str_replace( '+', '%20', $value['content'] );
					$value['content'] = str_replace( '%5B%40plus%40%5D', '+', $value['content'] );
					
					$xml .='<item
					author="'.$value['account'].'" 
					authorUid="'.$value['uid'].'" 
					clickto="itemId-'.$value['itemid'].'" 
					authorHead="'.$_ENV['multipleObj']->useravatar( $value['uid'], true, 'small' ).'" 
					itemId="'.$value['itemid'].'" 
					dateline="'.$this->dateFormat( $value['dateline'], 'date' ).'" 
					digg="'.$value['digg'].'" 
					reply="'.$value['reply'].'" 
					copy="'.$this->langs['copy_url'].'" 
					view="'.$this->langs['view_item'].'" 
					deleted="'.$this->langs['delete_item'].'" 
					>'.$value['content'].'</item>'."\n";
				}
				
				if( !empty( $hotItems ) )
				{
					foreach ( $hotItems as $value )
					{
						$value['content'] = str_replace( '+', '[@plus@]', $value['content'] );
						$value['account'] = urlencode( $this->d2s( $value['account'] ) );
						$value['content'] = urlencode( $value['content'] );
						$value['content'] = str_replace( '+', '%20', $value['content'] );
						$value['content'] = str_replace( '%5B%40plus%40%5D', '+', $value['content'] );
						
						$xml .='<hotitem
						author="'.$value['account'].'" 
						authorUid="'.$value['uid'].'" 
						clickto="itemId-'.$value['itemid'].'" 
						authorHead="'.$_ENV['multipleObj']->useravatar( $value['uid'], true, 'small' ).'" 
						itemId="'.$value['itemid'].'" 
						dateline="'.$this->dateFormat( $value['dateline'], 'date' ).'" 
						digg="'.$value['digg'].'" 
						reply="'.$value['reply'].'" 
						copy="'.$this->langs['copy_url'].'" 
						view="'.$this->langs['view_item'].'" 
						deleted="'.$this->langs['delete_item'].'" 
						>'.$value['content'].'</hotitem>'."\n";
					}
				}
				
			}
			else
			{
				foreach ( $items as $value )
				{
					$value['content'] = str_replace( '+', '[@plus@]', $value['content'] );
					$value['account'] = urlencode( $this->d2s( $value['account'] ) );
					$value['content'] = urlencode( $value['content'] );
					$value['content'] = str_replace( '+', '%20', $value['content'] );
					$value['content'] = str_replace( '%5B%40plus%40%5D', '+', $value['content'] );
					
					$xml .='<item
					author="'.$this->langs['anonymous'].'" 
					authorUid="0" 
					clickto="itemId-'.$value['itemid'].'" 
					authorHead="./sky/anonymous.gif" 
					itemId="'.$value['itemid'].'" 
					dateline="'.$this->dateFormat( $value['dateline'], 'date' ).'" 
					digg="'.$value['digg'].'" 
					reply="'.$value['reply'].'" 
					copy="'.$this->langs['copy_url'].'" 
					view="'.$this->langs['view_item'].'" 
					deleted="'.$this->langs['delete_item'].'" 
					>'.$value['content'].'</item>'."\n";
				}
				
				if( !empty( $hotItems ) )
				{
					foreach ( $hotItems as $value )
					{
						$value['content'] = str_replace( '+', '[@plus@]', $value['content'] );
						$value['account'] = urlencode( $this->d2s( $value['account'] ) );
						$value['content'] = urlencode( $value['content'] );
						$value['content'] = str_replace( '+', '%20', $value['content'] );
						$value['content'] = str_replace( '%5B%40plus%40%5D', '+', $value['content'] );
						
						$xml .='<hotitem
						author="'.$this->langs['anonymous'].'" 
						authorUid="0" 
						clickto="itemId-'.$value['itemid'].'" 
						authorHead="./sky/anonymous.gif" 
						itemId="'.$value['itemid'].'" 
						dateline="'.$this->dateFormat( $value['dateline'], 'date' ).'" 
						digg="'.$value['digg'].'" 
						reply="'.$value['reply'].'" 
						copy="'.$this->langs['copy_url'].'" 
						view="'.$this->langs['view_item'].'" 
						deleted="'.$this->langs['delete_item'].'" 
						>'.$value['content'].'</hotitem>'."\n";
					}
					
				}
			}
			
			echo $xml;
			
			echo '</items>';
			
		}
		else
		{
			echo '<items pageNums="0" itemsNums="0" nowDate="'.$this->dateFormat( $this->config['nowtime'] ).'">'."\n";
			
			echo '</items>';
		}
	}
	
	//新建一个天空内容
	function newItemAction()
	{
		$lastPostTime = $this->session( 'postItemTime' );
		$lastPostTime =  $lastPostTime[0];
		
		if(  $lastPostTime + $this->config['item']['postTimeLimit'] > $this->config['nowtime'] )
		{
			$this->dataReturn( $this->replaceLangVars( '{time}', $this->config['item']['postTimeLimit'], $this->langs['time_limit_between_two_send'] ), 'failed' );
		}
		
		$userinfo = $this->checkLogin();
		
		if( empty( $userinfo ) )
		$this->dataReturn( $this->langs['can_not_do_this_without_login'], 'failed' );
		
	
		$content =  $this->post['content'];
		
		if( !$this->checkLength( $content, $this->config['item']['minLength'], $this->config['item']['maxLength'] ) )
		$this->dataReturn( $this->replaceLangVars( array( '{minlen}', '{maxlen}' ), array( $this->config['item']['minLength'], $this->config['item']['maxLength'] ), $this->langs['item_length_limit'] ), 'failed' );
		
		$itemId = $_ENV['skyItemModel']->newItem( $content, $userinfo['uid'], $userinfo['username'], $this->config['nowtime'] );
		
		if( $itemId > 0 )
		{
			if( $this->config['newItemAddFeed'] == 1 && $this->config['showUserInfo'] == 1 )
			{
				$subjectLink =$this->config['flash']['skyUrl'].'/?index-index/itemId-'.$itemId;
				
				$spaceUrl = $this->config['flash']['spaceUrl'];
				
				$subjectSearchArray = array( '{fromuser}', '{touser}' );
				$subjectReplaceArray[] = '<a href="'.$spaceUrl.$userinfo['uid'].'" target="_blank">'.$userinfo['username'].'</a>&nbsp;';
				$subjectReplaceArray[] = '';
				
				$subject = str_replace( $subjectSearchArray, $subjectReplaceArray, $this->config['feedNewItemTitle'] );
				
				$_ENV['multipleObj']->addFeed( $userinfo['uid'], $userinfo['username'], $subjectLink, $subject, $subjectLink, $content );
				
			}
			
			$this->session( 'postItemTime', array( $this->config['nowtime'] ) );
			$this->dataReturn( $itemId );
		}
		else
		{
			$this->dataReturn( $this->langs['data_store_fail'], 'failed' );
		}
	}
	
	function broadcastAction()
	{
		$broadcasts = $_ENV['broadcastModel']->broadcasts( 0, $this->config['broadcastNum'] );
		$this->xmlHeader();
		
		$xml ='<broadcasts>';
		if( is_array( $broadcasts ) && !empty( $broadcasts ) )
		{
			foreach ( $broadcasts as $value )
			{
				$xml .="<broadcast gourl=\"".urlencode( $value['gourl'] )."\">{$value['content']}</broadcast>";
			}
			
		}
		$xml .='</broadcasts>';
		
		echo $xml;
	}
	
	
}

?>